open-src/data/ogl-select/mesa_vendor_select
changeset 970 272328fe1b4a
child 1152 6cf0f98f6d5f
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/open-src/data/ogl-select/mesa_vendor_select	Fri Jul 02 21:03:57 2010 -0700
@@ -0,0 +1,107 @@
+#!/bin/ksh93
+#
+# Copyright (c) 2006, 2010, Oracle and/or its affiliates. All rights reserved.
+#
+# Permission is hereby granted, free of charge, to any person obtaining a
+# copy of this software and associated documentation files (the "Software"),
+# to deal in the Software without restriction, including without limitation
+# the rights to use, copy, modify, merge, publish, distribute, sublicense,
+# and/or sell copies of the Software, and to permit persons to whom the
+# Software is furnished to do so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice (including the next
+# paragraph) shall be included in all copies or substantial portions of the
+# Software.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+# DEALINGS IN THE SOFTWARE.
+#
+#
+
+LINKDIR=/var/run/opengl
+
+PATH=/usr/bin:/usr/sbin
+
+ARCH="$(uname -p)"
+
+case "${ARCH}" in
+    sparc)	DIR64="sparcv9" ;;
+    i386)	DIR64="amd64"	;;
+    *)		exit 1		;; # Unknown architecture
+esac
+
+if [[ $# -eq 1 ]]; then
+	# If this is just a probe, identify ourself and leave.
+	if [[ $1 == "identify" ]]; then
+		if [[ "${ARCH}" == "i386" ]] ; then
+		    print "SUNWtext mesa"
+		fi
+		# Already is the default fallback for all platforms
+		return 0
+	fi
+	# Build links under an alternate root if root=/path is passed
+	if [[ "$1" =~ root=.* ]] ; then
+	    LINKDIR="${1#root=}${LINKDIR}"
+	fi
+fi
+
+# Make a directory. $1 is the pathname.
+function make_dir {
+	if [[ $# != 1 ]]; then
+		return
+	fi
+	if [[ ! -d $1 ]]; then
+		mkdir -p $1
+	fi	
+	chmod 755 $1
+}
+
+# Make a file link. $1 is the source path, $2 is the target path
+function make_link {
+	if [[ $# != 2 ]]; then
+		return
+	fi
+	if [[ -h $2 ]]; then
+		rm -f $2
+	fi
+	ln -sf $1 $2
+}
+
+# Create directories
+make_dir ${LINKDIR}
+make_dir ${LINKDIR}/lib
+make_dir ${LINKDIR}/lib/${DIR64}
+make_link ${DIR64} ${LINKDIR}/lib/64
+make_dir ${LINKDIR}/include
+make_dir ${LINKDIR}/server
+
+if [[ -d /usr/lib/mesa/modules/extensions/${DIR64} ]] ; then
+    make_dir ${LINKDIR}/server/${DIR64}
+fi
+
+# User libraries
+make_link ../../../../usr/lib/mesa/libGL.so.1 ${LINKDIR}/lib/libGL.so.1
+make_link ../../../../../usr/lib/mesa/${DIR64}/libGL.so.1 \
+	${LINKDIR}/lib/${DIR64}/libGL.so.1
+
+# Server modules
+make_link ../../../../usr/lib/mesa/modules/extensions/libglx.so \
+	${LINKDIR}/server/libglx.so
+if [[ -d /usr/lib/mesa/modules/extensions/${DIR64} ]] ; then
+    make_link \
+	../../../../../usr/lib/mesa/modules/extensions/${DIR64}/libglx.so \
+	${LINKDIR}/server/${DIR64}/libglx.so
+fi
+
+# Includes
+make_link ../../../../usr/include/mesa/gl.h	${LINKDIR}/include/gl.h
+make_link ../../../../usr/include/mesa/glext.h	${LINKDIR}/include/glext.h
+make_link ../../../../usr/include/mesa/glx.h	${LINKDIR}/include/glx.h
+make_link ../../../../usr/include/mesa/glxext.h	${LINKDIR}/include/glxext.h
+
+return 0